/************************************************************
* $Id: main.c,v 1.8 2014/11/19 07:52:23 mechanoid Exp $
*       
*       OS : GNU/Linux 3.14.19 
* COMPILER : GNU project C and C++ Compiler  v. 4.9.1
*
*   AUTHOR : Evgeny S. Borisov
*
*  Glushkov Institute of Cybernetics
*  National Academy of Sciences of Ukraine
* 
*    http://www.mechanoid.kiev.ua
*  e-mail : cv@mechanoid.kiev.ua
* 
************************************************************/


#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <signal.h>

#include "http_server.h"
#include "bot_ctrl.h"

int init();
int run();
void done();


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
int main(int argc, char* argv[]) {
   if( !init() ) { run(); }
   done();
   return 0;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
int init(){
   if( signal(SIGINT,done) == SIG_ERR) { fprintf(stderr,"signal: %s\n",strerror(errno)); return 1; } 
   if( bot_init() ) { return 2; }
   if( http_server_init() ) { return 3; }

   return 0;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
int run(){
   return bot_run();
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
void done(){
   http_server_done();
   bot_done();
   fprintf(stdout,"[i] close server\n") ;
   exit(0);
}


