/************************************************************
* $Id: video.c,v 1.8 2014/11/21 10:52:02 mechanoid Exp $
*       
*       OS : GNU/Linux 3.14.19 
* COMPILER : GNU project C and C++ Compiler  v. 4.9.1
*
*   AUTHOR : Evgeny S. Borisov
*
*  Glushkov Institute of Cybernetics
*  National Academy of Sciences of Ukraine
* 
*    http://www.mechanoid.kiev.ua
*  e-mail : cv@mechanoid.kiev.ua
* 
************************************************************/


#include <string.h>
#include <stdio.h>
#include <errno.h>

#include "video.h"

 
#define VIDEO_FRAME_WIDTH  160
#define VIDEO_FRAME_HEIGHT 120

// #define VIDEO_FRAME_WIDTH  320
// #define VIDEO_FRAME_HEIGHT 240


CvCapture* capture;
IplImage* frame;

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
int video_init() {
   int w,h;
   // получаем видео-поток
   if(!(capture=cvCreateCameraCapture(0))) {
	  fprintf(stderr,"[E] cvCreateCameraCapture: %s\n",strerror(errno)) ;
	  return 1; 
   }
   cvSetCaptureProperty( capture, CV_CAP_PROP_FRAME_WIDTH, VIDEO_FRAME_WIDTH );
   cvSetCaptureProperty( capture, CV_CAP_PROP_FRAME_HEIGHT, VIDEO_FRAME_HEIGHT );

   frame=cvQueryFrame( capture );
   if(!frame) { fprintf(stderr,"[E] cvQueryFrame error\n "); return 2;   }

   w=frame->width;
   h=frame->height;
   fprintf(stdout,"[i] camera activated %ix%i \n",w,h);


   return 0;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
void video_done(){
   cvReleaseImage( &frame );
   cvReleaseCapture( &capture );

   fprintf(stdout,"[i] close video\n") ;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
int video_get_frame(){
   // получаем кадр 
   frame=cvQueryFrame( capture );
   if(!frame) { fprintf(stderr,"[E] cvQueryFrame error\n "); return 2;   }
   return 0;
}



/*
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
void* video_get_jpeg(int *size) {
   void* buf;
   int s=0;

   pthread_mutex_lock(&cs_frame);

	  if(mat==NULL) {
		 pthread_mutex_unlock(&cs_frame);
		 fprintf(stderr,"[E] frame is null\n") ;
		 return NULL;
	  }

	  s=mat->cols*CV_ELEM_SIZE(CV_MAT_TYPE( mat->type))*mat->rows*sizeof(uchar);
      buf=malloc(s);
	  if(buf==NULL) {
		 pthread_mutex_unlock(&cs_frame);
		 fprintf(stderr,"[E] malloc: %s\n",strerror(errno)) ;
		 return NULL;
	  }
	  *size=s; 
	  memcpy(buf,(void *)mat->data.ptr,s);

   pthread_mutex_unlock(&cs_frame);

   return buf;
}



// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
int video_encode_frame(){ 
   pthread_mutex_lock(&cs_frame);
	  if(mat!=NULL) { cvReleaseMat( &mat ) ; mat=NULL; }
	  mat = cvEncodeImage(".jpg", frame,0);
   pthread_mutex_unlock(&cs_frame);
   return 0;
}
*/


